package net.sf.jabref;

import javax.swing.*;
import java.awt.*;

import com.jgoodies.forms.layout.*;
import com.jgoodies.forms.builder.*;

public class ExternalTab extends JPanel implements PrefsTab {

    JabRefPreferences _prefs;
    JabRefFrame _frame;
    //private JComboBox language = new JComboBox(GUIGlobals.LANGUAGES.keySet().toArray());
    JTextField pdfDir, psDir, pdf, ps, html, lyx, winEdt, citeCommand;
    JTextField app0,app1,app2,app3,app4,app5,app6,app7,app8,app9; // AF
    JTextField app0ext,app1ext,app2ext,app3ext,app4ext; // AF
    JTextField app5ext,app6ext,app7ext,app8ext,app9ext; // AF

    //private HelpAction ownerHelp, pdfHelp;


    public ExternalTab(JabRefFrame frame, JabRefPreferences prefs) {
        _prefs = prefs;
        _frame = frame;
        setLayout(new BorderLayout());

        //pdfHelp = new HelpAction(frame.helpDiag, GUIGlobals.pdfHelp,
        //        "Help", GUIGlobals.helpSmallIconFile);

        psDir = new JTextField(30);
        pdfDir = new JTextField(30);
        pdf = new JTextField(30);
        ps = new JTextField(30);
        html = new JTextField(30);
        lyx = new JTextField(30);
        winEdt = new JTextField(30);
        citeCommand = new JTextField(30);

        app0 = new JTextField(30); // AF
        app1 = new JTextField(30); // AF
        app2 = new JTextField(30); // AF
        app3 = new JTextField(30); // AF
        app4 = new JTextField(30); // AF
        app5 = new JTextField(30); // AF
        app6 = new JTextField(30); // AF
        app7 = new JTextField(30); // AF
        app8 = new JTextField(30); // AF
        app9 = new JTextField(30); // AF
        app0ext = new JTextField(30); // AF
        app1ext = new JTextField(30); // AF
        app2ext = new JTextField(30); // AF
        app3ext = new JTextField(30); // AF
        app4ext = new JTextField(30); // AF
        app5ext = new JTextField(30); // AF
        app6ext = new JTextField(30); // AF
        app7ext = new JTextField(30); // AF
        app8ext = new JTextField(30); // AF
        app9ext = new JTextField(30); // AF

        BrowseAction browse;

        FormLayout layout = new FormLayout
                ("1dlu, 8dlu, left:pref, 4dlu, fill:200dlu, 4dlu, fill:pref",// 4dlu, left:pref, 4dlu",
                        "");

        DefaultFormBuilder builder = new DefaultFormBuilder(layout);

        builder.appendSeparator(Globals.lang("PDF links"));
        JPanel pan = new JPanel();
        builder.append(pan);
        JLabel lab = new JLabel(Globals.lang("Main PDF directory") + ":");
        builder.append(lab);
        builder.append(pdfDir);
        browse = new BrowseAction(_frame, pdfDir, true);
        builder.append(new JButton(browse));
        builder.nextLine();
        builder.appendSeparator(Globals.lang("PS links"));
        pan = new JPanel();
        builder.append(pan);
        lab = new JLabel(Globals.lang("Main PS directory") + ":");
        builder.append(lab);
        builder.append(psDir);
        browse = new BrowseAction(_frame, psDir, true);
        builder.append(new JButton(browse));
        builder.nextLine();
        builder.appendSeparator(Globals.lang("External programs"));


        builder.nextLine();
        lab = new JLabel(Globals.lang("Path to PDF viewer") + ":");
        builder.append(pan);
        builder.append(lab);
        builder.append(pdf);
        browse = new BrowseAction(_frame, pdf, false);
        if (Globals.ON_WIN)
            browse.setEnabled(false);
        builder.append(new JButton(browse));
        builder.nextLine();
        lab = new JLabel(Globals.lang("Path to PS viewer") + ":");
        builder.append(pan);
        builder.append(lab);
        builder.append(ps);
        browse = new BrowseAction(_frame, ps, false);
        if (Globals.ON_WIN)
            browse.setEnabled(false);
        builder.append(new JButton(browse));
        builder.nextLine();
        lab = new JLabel(Globals.lang("Path to HTML viewer") + ":");
        builder.append(pan);
        builder.append(lab);
        builder.append(html);
        browse = new BrowseAction(_frame, html, false);
        if (Globals.ON_WIN)
            browse.setEnabled(false);
        builder.append(new JButton(browse));
        builder.nextLine();
        lab = new JLabel(Globals.lang("Path to LyX pipe") + ":");
        builder.append(pan);
        builder.append(lab);
        builder.append(lyx);
        browse = new BrowseAction(_frame, lyx, false);
        builder.append(new JButton(browse));
        builder.nextLine();
        lab = new JLabel(Globals.lang("Path to WinEdt.exe") + ":");
        builder.append(pan);
        builder.append(lab);
        builder.append(winEdt);
        browse = new BrowseAction(_frame, winEdt, false);
        builder.append(new JButton(browse));
        builder.nextLine();
        builder.append(pan);
        builder.append(Globals.lang("Cite command (for Emacs/WinEdt)")+":");
        builder.append(citeCommand);
        //builder.appendSeparator();

        // AF
        // TODO: Globals.lang ...
        builder.nextLine(); // AF
        builder.appendSeparator("Applications to run on file extentions"); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append("Application 0:"); // AF
        builder.append(app0); // AF
        browse = new BrowseAction(_frame, app0, false); // AF
        if(Globals.ON_WIN) browse.setEnabled(false); // AF
        builder.append(new JButton(browse)); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append(""); // AF
        builder.append(app0ext); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append("Application 1:"); // AF
        builder.append(app1); // AF
        browse = new BrowseAction(_frame, app1, false); // AF
        if(Globals.ON_WIN) browse.setEnabled(false); // AF
        builder.append(new JButton(browse)); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append(""); // AF
        builder.append(app1ext); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append("Application 2:"); // AF
        builder.append(app2); // AF
        browse = new BrowseAction(_frame, app2, false); // AF
        if(Globals.ON_WIN) browse.setEnabled(false); // AF
        builder.append(new JButton(browse)); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append(""); // AF
        builder.append(app2ext); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append("Application 3:"); // AF
        builder.append(app3); // AF
        browse = new BrowseAction(_frame, app3, false); // AF
        if(Globals.ON_WIN) browse.setEnabled(false); // AF
        builder.append(new JButton(browse)); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append(""); // AF
        builder.append(app3ext); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append("Application 4:"); // AF
        builder.append(app4); // AF
        browse = new BrowseAction(_frame, app4, false); // AF
        if(Globals.ON_WIN) browse.setEnabled(false); // AF
        builder.append(new JButton(browse)); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append(""); // AF
        builder.append(app4ext); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append("Application 5:"); // AF
        builder.append(app5); // AF
        browse = new BrowseAction(_frame, app5, false); // AF
        if(Globals.ON_WIN) browse.setEnabled(false); // AF
        builder.append(new JButton(browse)); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append(""); // AF
        builder.append(app5ext); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append("Application 6:"); // AF
        builder.append(app6); // AF
        browse = new BrowseAction(_frame, app6, false); // AF
        if(Globals.ON_WIN) browse.setEnabled(false); // AF
        builder.append(new JButton(browse)); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append(""); // AF
        builder.append(app6ext); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append("Application 7:"); // AF
        builder.append(app7); // AF
        browse = new BrowseAction(_frame, app7, false); // AF
        if(Globals.ON_WIN) browse.setEnabled(false); // AF
        builder.append(new JButton(browse)); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append(""); // AF
        builder.append(app7ext); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append("Application 8:"); // AF
        builder.append(app8); // AF
        browse = new BrowseAction(_frame, app8, false); // AF
        if(Globals.ON_WIN) browse.setEnabled(false); // AF
        builder.append(new JButton(browse)); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append(""); // AF
        builder.append(app8ext); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append("Application 9:"); // AF
        builder.append(app9); // AF
        browse = new BrowseAction(_frame, app9, false); // AF
        if(Globals.ON_WIN) browse.setEnabled(false); // AF
        builder.append(new JButton(browse)); // AF
        builder.nextLine(); // AF
        builder.append(pan); // AF
        builder.append(""); // AF
        builder.append(app9ext); // AF

        pan = builder.getPanel();
        pan.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
        add(pan, BorderLayout.CENTER);
    }

    public void setValues() {
        pdfDir.setText(_prefs.get("pdfDirectory"));
        psDir.setText(_prefs.get("psDirectory"));
        if (!Globals.ON_WIN) {
            pdf.setText(_prefs.get("pdfviewer"));
            ps.setText(_prefs.get("psviewer"));
            html.setText(_prefs.get("htmlviewer"));
            app0.setText(_prefs.get("application0")); // AF
            app1.setText(_prefs.get("application1")); // AF
            app2.setText(_prefs.get("application2")); // AF
            app3.setText(_prefs.get("application3")); // AF
            app4.setText(_prefs.get("application4")); // AF
            app5.setText(_prefs.get("application5")); // AF
            app6.setText(_prefs.get("application6")); // AF
            app7.setText(_prefs.get("application7")); // AF
            app8.setText(_prefs.get("application8")); // AF
            app9.setText(_prefs.get("application9")); // AF
            app0ext.setText(_prefs.get("extApplication0")); // AF
            app1ext.setText(_prefs.get("extApplication1")); // AF
            app2ext.setText(_prefs.get("extApplication2")); // AF
            app3ext.setText(_prefs.get("extApplication3")); // AF
            app4ext.setText(_prefs.get("extApplication4")); // AF
            app5ext.setText(_prefs.get("extApplication5")); // AF
            app6ext.setText(_prefs.get("extApplication6")); // AF
            app7ext.setText(_prefs.get("extApplication7")); // AF
            app8ext.setText(_prefs.get("extApplication8")); // AF
            app9ext.setText(_prefs.get("extApplication9")); // AF
        } else {
            pdf.setText(Globals.lang("Uses default application"));
            ps.setText(Globals.lang("Uses default application"));
            html.setText(Globals.lang("Uses default application"));
            pdf.setEnabled(false);
            ps.setEnabled(false);
            html.setEnabled(false);
            app0.setText(Globals.lang("Uses default application")); // AF
            app1.setText(Globals.lang("Uses default application")); // AF
            app2.setText(Globals.lang("Uses default application")); // AF
            app3.setText(Globals.lang("Uses default application")); // AF
            app4.setText(Globals.lang("Uses default application")); // AF
            app5.setText(Globals.lang("Uses default application")); // AF
            app6.setText(Globals.lang("Uses default application")); // AF
            app7.setText(Globals.lang("Uses default application")); // AF
            app8.setText(Globals.lang("Uses default application")); // AF
            app9.setText(Globals.lang("Uses default application")); // AF
            app0.setEnabled(false); // AF
            app1.setEnabled(false); // AF
            app2.setEnabled(false); // AF
            app3.setEnabled(false); // AF
            app4.setEnabled(false); // AF
            app5.setEnabled(false); // AF
            app6.setEnabled(false); // AF
            app7.setEnabled(false); // AF
            app8.setEnabled(false); // AF
            app9.setEnabled(false); // AF
            app0ext.setEnabled(false); // AF
            app1ext.setEnabled(false); // AF
            app2ext.setEnabled(false); // AF
            app3ext.setEnabled(false); // AF
            app4ext.setEnabled(false); // AF
            app5ext.setEnabled(false); // AF
            app6ext.setEnabled(false); // AF
            app7ext.setEnabled(false); // AF
            app8ext.setEnabled(false); // AF
            app9ext.setEnabled(false); // AF
        }

        lyx.setText(_prefs.get("lyxpipe"));
        winEdt.setText(_prefs.get("winEdtPath"));
        citeCommand.setText(_prefs.get("citeCommand"));
    }

    public void storeSettings() {

        // We should maybe do some checking on the validity of the contents?
        _prefs.put("pdfDirectory", pdfDir.getText());
        _prefs.put("psDirectory", psDir.getText());
        _prefs.put("pdfviewer", pdf.getText());
        _prefs.put("psviewer", ps.getText());
        _prefs.put("htmlviewer", html.getText());
        _prefs.put("lyxpipe", lyx.getText());
        _prefs.put("winEdtPath", winEdt.getText());
        _prefs.put("citeCommand", citeCommand.getText());
        _prefs.put("application0", app0.getText()); // AF
        _prefs.put("application1", app1.getText()); // AF
        _prefs.put("application2", app2.getText()); // AF
        _prefs.put("application3", app3.getText()); // AF
        _prefs.put("application4", app4.getText()); // AF
        _prefs.put("application5", app5.getText()); // AF
        _prefs.put("application6", app6.getText()); // AF
        _prefs.put("application7", app7.getText()); // AF
        _prefs.put("application8", app8.getText()); // AF
        _prefs.put("application9", app9.getText()); // AF
        boolean updateSpecialFields=false; // AF
        if(!app0ext.getText().trim().equals(_prefs.get("extApplication0"))) { // AF
          _prefs.put("extApplication0", app0ext.getText()); // AF
          updateSpecialFields=true; // AF
        } // AF
        if(!app1ext.getText().trim().equals(_prefs.get("extApplication1"))) { // AF
          _prefs.put("extApplication1", app1ext.getText()); // AF
          updateSpecialFields=true; // AF
        } // AF
        if(!app2ext.getText().trim().equals(_prefs.get("extApplication2"))) { // AF
          _prefs.put("extApplication2", app2ext.getText()); // AF
          updateSpecialFields=true; // AF
        } // AF
        if(!app3ext.getText().trim().equals(_prefs.get("extApplication3"))) { // AF
          _prefs.put("extApplication3", app3ext.getText()); // AF
          updateSpecialFields=true; // AF
        } // AF
        if(!app4ext.getText().trim().equals(_prefs.get("extApplication4"))) { // AF
          _prefs.put("extApplication4", app4ext.getText()); // AF
          updateSpecialFields=true; // AF
        } // AF
        if(!app5ext.getText().trim().equals(_prefs.get("extApplication5"))) { // AF
          _prefs.put("extApplication5", app5ext.getText()); // AF
          updateSpecialFields=true; // AF
        } // AF
        if(!app6ext.getText().trim().equals(_prefs.get("extApplication6"))) { // AF
          _prefs.put("extApplication6", app6ext.getText()); // AF
          updateSpecialFields=true; // AF
        } // AF
        if(!app7ext.getText().trim().equals(_prefs.get("extApplication7"))) { // AF
          _prefs.put("extApplication7", app7ext.getText()); // AF
          updateSpecialFields=true; // AF
        } // AF
        if(!app8ext.getText().trim().equals(_prefs.get("extApplication8"))) { // AF
          _prefs.put("extApplication8", app8ext.getText()); // AF
          updateSpecialFields=true; // AF
        } // AF
        if(!app9ext.getText().trim().equals(_prefs.get("extApplication9"))) { // AF
          _prefs.put("extApplication9", app9ext.getText()); // AF
          updateSpecialFields=true; // AF
        } // AF
        if(updateSpecialFields) _prefs.updateSpecialFieldHandling(); // AF
    }

    public boolean readyToClose() {
        return true;
    }

}
